"use strict";

function elm(id){
    var e=document.getElementById(id);
    if(!e)console.error("ERROR: element with id="+id+" does not exist");
    return e;
}
function elmShow(id){
    document.getElementById(id).style.display='block';
}
function elmShowI(id){
    document.getElementById(id).style.display='inline';
}
function elmHide(id){
    document.getElementById(id).style.display='none';
}
function elmClear(id){
    document.getElementById(id).style.display='';
}
function elmHTML(id,txt){
    document.getElementById(id).innerHTML=txt;
}
function elmHTMLshow(id,txt){
    var e=document.getElementById(id);
    e.innerHTML=txt;
    e.style.display='block';
}
function elmBindPdSp(id,f){
    document.getElementById(id).addEventListener('click',function(e){
        e.preventDefault();
        e.stopPropagation();
        f(e);
    },false);
}

function parseJSON(txt){
    var obj;
    try {
        obj=JSON.parse(txt);
        return obj;
    } catch (e) {
        console.log("JSON.parse returned an error for this string: "+txt);
        console.log("The error was:");
        console.log(e);
        return null;
    }
}
function ajaxJson(url,f){
    var x=new XMLHttpRequest();
    x.onreadystatechange=function() {
        if(x.readyState===4){
            if(x.status===200){
                console.log(x.responseText);
                var obj=parseJSON(x.responseText);
                console.assert(typeof(obj)==='object');
                if(f)
                    f(obj);
            } else {
                console.warn("WARNING: XMLHttprequest failed: "+x.statusText);
                console.warn(x);
                if(f)
                    f();
            }
        }
    };
    x.open('GET',url,true);
    x.setRequestHeader("Content-Type", "application/json; charset=utf-8");
    x.timeout=20000; //20 seconds
    x.send(null);
}

function getURLParam (oTarget, sVar) {
    return decodeURI(oTarget.search.replace(new RegExp("^(?:.*[&\\?]" + encodeURI(sVar).replace(/[\.\+\*]/g, "\\$&") + "(?:\\=([^&]*))?)?.*$", "i"), "$1"));
    //how to use: alert(getURLParam(window.location, "name"));
}

function clone(obj) {
    var copy;

    // Handle the 3 simple types, and null or undefined
    if (null === obj || "object" !== typeof obj) return obj;

    // Handle Date
    if (obj instanceof Date) {
        copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
    }

    // Handle Array
    if (obj instanceof Array) {
        copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
            copy[i] = clone(obj[i]);
        }
        return copy;
    }

    // Handle Object
    if (obj instanceof Object) {
        copy = {};
        for (var attr in obj) {
            if (obj.hasOwnProperty(attr)) copy[attr] = clone(obj[attr]);
        }
        return copy;
    }

    throw new Error("Unable to copy obj! Its type isn't supported.");
}

/*
function addListener(obj,ev,fnct){
    if(obj.addEventListener){//All browsers, except IE before version 9.
        obj.addEventListener(ev,fnct,false);
    } else if(obj.attachEvent){//IE before version 9.
        ev=(ev==='DOMContentLoaded')?'onreadystatechange':'on'+ev;
        obj.attachEvent(ev,fnct);
    } else console.error("addListener: no way of attaching things!!");
}*/


