"use strict";

PH.applyServerMetadata=function(obj){
    var showAttention=false;
    var oldMetadata=PH.server.metadata;
    PH.server.metadata=obj;
    console.log("Metadata received: totalElements: "+obj.te+", scannedElements: "+obj.se+", received cameras: "+
            ((typeof(obj.m)!=='undefined')?obj.m.length:"none"));
    //console.log(obj);
    //apply server version
    var versionTxt=''+(PH.server.metadata.v>>8)+'.'+(PH.server.metadata.v%256);
    elmHTML('about_version',versionTxt);
    if(typeof(PH.server.metadata.n)==='number')elmHTML('about_nr_cameras',PH.server.metadata.n);
    else elmHTML('about_nr_cameras','unknown'); //TODO: translate this
    //check the status flags: are we reachable from outside?
    console.assert(typeof(PH.server.metadata.pcs)==='number');
    if(PH.server.metadata.pcs!==PH.server.phonetCfgStatus.PhonetCfgNeverTriedToRegister){
        //registration to photostovis.net done.
        if(PH.server.metadata.pcs!==0) //0 means success
            showAttention=true;//there was a problem with the server start command
        else if(typeof(PH.server.metadata.un)!=='string')
            showAttention=true;//this server is not registered to photostovis.net
    } //else registration in progress. Show something? Probably not

    if(showAttention){
        elmClear('attention-btn');
    }
    //console.log("Old metadata:");
    //console.log(oldMetadata);
    if(!oldMetadata){
        if(PH.path.length>0 && typeof(PH.path[PH.path.length-1].e)!=='undefined')
            PH.displayAlbum();
        //else do nothing
    }
};

PH.showBitrate=function(bitrate){
    if(bitrate<=0)return;
    this.currentBitrate=bitrate;
    this.lastBitrateUpdate=Date.now();
    var e=elm('bitrate'),efs=elm('fs_bitrate');
    efs.style.opacity=e.style.opacity='1';
    if(bitrate>1024){
        bitrate/=1024;
        if(bitrate>=10)
            efs.innerHTML=e.innerHTML=bitrate.toFixed(0)+"Mbps";
        else
            efs.innerHTML=e.innerHTML=bitrate.toFixed(1)+"Mbps";
    } else
        efs.innerHTML=e.innerHTML=bitrate+"Kbps";
    
    setTimeout(function(){
        //do we start fading out?
        var tNow=Date.now();
        if(tNow-PH.lastBitrateUpdate<10000)return;
        
        efs.style.transition=e.style.transition='opacity 3s linear';
        efs.style.opacity=e.style.opacity='0.01';
        setTimeout(function(){
            efs.style.transition=e.style.transition='';
        },3000);
    },10000);
};

PH.getServerMetadata=function(){
    var url='/m?smallDevice='+(PH.platform.smallDevice?'true':'false')+'&screenWidth='+PH.platform.screenWidth+'&screenHeight='+PH.platform.screenHeight+
            '&pixelRatio='+PH.platform.pixelRatio;
    if(PH.server.key)
        url+='&key='+PH.server.key;
    ajaxJson(url,PH.applyServerMetadata);
};

PH.savePreferences=function(overwrite){
    var jsonTxt,objToSend;

    jsonTxt=JSON.stringify(PH.user);
    localStorage.setItem('photostovisPreferences',jsonTxt);
    if(parent===self)return; //no parent to send

    if(typeof(overwrite)==='undefined')overwrite=true;
    objToSend={localStorageTxt:jsonTxt,overwrite:overwrite};
    parent.postMessage(objToSend,"*");
};

PH.showLanguageSelector=function(forbidDismiss){
    //pre-select the language, if any
    if(this.user.language){
        var i;
        var sel=document.getElementsByName('settings_lang');
        for(i=0;i<sel.length;i++)
            if(this.user.language===sel[i].value){
                sel[i].checked=true;
                elm('settings_btn_next').disabled=false;
                break;
            }
    }
    elmShow('settings_lng');
    elmShow('settings_bg');
    this.settingShows='lng';
    if(forbidDismiss){
        this.settingAllowDismiss=false;
        elmHide('settings_btn_cancel');
    } else {
        this.settingAllowDismiss=true;
        elmClear('settings_btn_cancel');
    }
};

PH.showLogin=function(){
    elm('settings_btn_next').disabled=false;

    elmClear('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_lgn');
    elmShow('settings_bg');
    this.settingShows='lgn';
    this.settingAllowDismiss=true;
}
PH.showFullScreenDialog=function(){
    elmHide('settings_btn_next');
    elmHide('settings_btn_cancel');
    elmShow('settings_efs');
    elmShow('settings_bg');
    this.settingShows='efs';
    this.settingAllowDismiss=false;
}

PH.showUpload=function(){
    elm('settings_btn_next').disabled=true;
    elm('settings_upl').style.width=(document.body.clientWidth/2)+'px';
    elmClear('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_upl');
    elmShow('settings_bg');
    this.settingShows='upl';
    this.settingAllowDismiss=false;
};
PH.showLink=function(){
    elm('settings_btn_next').disabled=false;
    elm('settings_lnk_link').value='';
    elmHide('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_lnk');
    elmShow('settings_bg');
    this.settingShows='lnk';
    this.settingAllowDismiss=true;
    
    //send the request to the server 
    var url='/k',i;
    for(i=1;i<this.path.length;i++)
        url+='/'+this.path[i].a.id;
    if(this.server.key)
        url+='?key='+PH.server.key;
    ajaxJson(url,function(obj){
        var e=elm('settings_lnk_link');
        if(typeof(obj)==='object'){
            if(typeof(obj.link)==='string'){
                e.value=obj.link;
                e.focus();
                e.select();
            } else if(typeof(obj.err)==='number')
                e.value="Server is not registered to phonet";
            else 
                e.value="Unspecified error retrieving link from the server.";
        } else
            e.value="Unspecified error retrieving link from the server (returned data not understood).";
    });
};

PH.showDownloadZip=function(){
    elm('settings_btn_next').disabled=true;
    elm('zip_progress_bar').style.width='0';
    
    elmClear('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_zip');
    elmShow('settings_bg');
    this.settingAllowDismiss=true;
    this.settingShows='zip';
    this.zipDownload=true;
    
    //send the request for size to the server 
    var url='/n',i;
    for(i=1;i<this.path.length;i++)
        url+='/'+this.path[i].a.id;
    if(this.server.key)
        url+='?key='+PH.server.key;
    ajaxJson(url,function(obj){
        var e=elm('settings_zip_txt');
        if(typeof(obj)==='object'){
            if(typeof(obj.sz)==='number' && typeof(obj.p)==='number' && typeof(obj.v)==='number'){
                if(typeof(PH.zipDownload)==='boolean' && PH.zipDownload===true){
                    e.innerHTML='<p>The zip file is being prepared. This will take some time.<br>(The download will have approx '+
                            obj.sz+'MB and will contain '+obj.p+' pictures and '+obj.v+' videos.</p>';
                    PH.zipDownload=obj;
                }// else we should be downloading the file already, or there was a cancel, or something
            } else if(typeof(obj.err)==='number'){
                if(obj.err===-10)
                    e.innerHTML='<p>This album is too big to be downloaded as zip. Album size: '+obj.sz+'MB.</p>';
                else 
                    e.innerHTML='<p>Preparing the album zip file failed. Error: '+obj.err+'</p>';
            } else 
                e.innerHTML='<p>Preparing the album zip file failed: unknown error.</p>';
        } else
            e.innerHTML='<p>Preparing the album zip file failed: Unspecified error (returned data not understood).</p>';
    });
};

PH.showRegistrationErr=function(){
    var notificationTxt='';
    console.log("showRegistrationErr");
    console.assert(typeof(this.server.metadata.pcs)==='number');

    if(this.server.metadata.pcs!==this.server.phonetCfgStatus.PhonetCfgNeverTriedToRegister){
        if(this.server.metadata.pcs>0){
            //there were problems with the start server command
            if(this.server.metadata.gcs!==0){
                //there was a problem with the internet gateway configuration
                notificationTxt+='<p>'+this.l10n('txt_err_upnp')+'</p><p>'+this.l10nGatewayConfigError(this.server.metadata.gcs)+'</p>';
            }
            if(this.server.metadata.pcs!==0){
                //there was a problem with phonet registration
                notificationTxt+='<p>'+this.l10n('txt_err_phonet')+'</p><p>'+this.l10nPhonetStartError(this.server.metadata.pcs)+'</p>';
            }
        } else {
            //server start was successfull
            if(typeof(this.server.metadata.un)!=='string'){
                notificationTxt+='<p>'+this.l10nPhonetStartError(this.server.metadata.pcs)+
                        '<button type="button" id="message-btn-register" onclick="PH.showRegistration()">'+
                        (this.server.metadata.pe?this.l10n('txt_reregister_srv'):this.l10n('txt_register_srv'))+'</button></p>';
            }
        }
    }
    console.assert(notificationTxt!==''); //we have something to show

    //display the notifications
    elmHTML('settings_rer',notificationTxt);
    elmClear('settings_btn_cancel');
    elmHide('settings_btn_next');

    elmShow('settings_rer');
    elmShow('settings_bg');
    this.settingShows='rer';
    this.settingAllowDismiss=true;
};

PH.showRegistration=function(){
    //hide the attention messages
    elmHide('settings_rer');
    //unhighlight the attention button
    if(!this.platform.isTouch)
        elm('attention-btn').setAttribute('class','nontouch');
    else
        elm('attention-btn').setAttribute('class','');

    
    //show the registration settings
    elm('settings_btn_next').disabled=false;
    
    elmClear('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_reg');
    elmShow('settings_bg');
    this.settingShows='reg';
    this.settingAllowDismiss=true;
};

PH.showShutdown=function(){
    //show the shutdown settings        
    elm('settings_btn_next').disabled=false;
    
    elmClear('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_off');
    elmShow('settings_bg');
    this.settingShows='off';
    this.settingAllowDismiss=true;
};
PH.showAbout=function(){
    elm('settings_btn_next').disabled=false;
    
    elmHide('settings_btn_cancel');
    elmClear('settings_btn_next');
    elmShow('settings_abt');
    elmShow('settings_bg');
    this.settingShows='abt';
    this.settingAllowDismiss=true;  
};

PH.onRegisterUsernameChanged=function(){
    var txt=document.getElementById('settings_reg_un').value;
    //change the link
    console.log("onRegisterUsernameChanged "+txt);
    if(txt==='')txt='username';
    elmHTML('settings_reg_un_link',txt);
};

PH.onUploadSubfolderChanged=function(){
    var txt=document.getElementById('upl_subfolder').value.trim();
    console.log("onUploadSubfolderChanged: <<"+txt+">>");
    //enable/disable the settings_btn_next button
    if(txt.length>0 || (PH.server.completedUploads>0 && PH.server.queuedUploads===0))
        elm('settings_btn_next').disabled=false;
    else
        elm('settings_btn_next').disabled=true;
};

PH.showMessage=function(txt, waiting){
    elmHTML('message-box-msg',txt);
    
    if(waiting){
        if(!this.spinner){
            var opts={
              lines: 11, // The number of lines to draw
              length: 10, // The length of each line
              width: 6, // The line thickness
              radius: 15, // The radius of the inner circle
              corners: 1, // Corner roundness (0..1)
              rotate: 0, // The rotation offset
              direction: 1, // 1: clockwise, -1: counterclockwise
              color: '#000', // #rgb or #rrggbb or array of colors
              speed: 1, // Rounds per second
              trail: 60, // Afterglow percentage
              shadow: false, // Whether to render a shadow
              hwaccel: false, // Whether to use hardware acceleration
              className: 'spinner', // The CSS class to assign to the spinner
              zIndex: 2e9, // The z-index (defaults to 2000000000)
              top: '50%', // Top position relative to parent
              left: '50%' // Left position relative to parent
            };
            this.spinner=new Spinner(opts).spin(elm('message-box-spinner'));
        } else this.spinner.spin(elm('message-box-spinner'));
        elmClear('message-box-spinner');
        elmHide('message-box-btn-ok');
    } else {
        elmHide('message-box-spinner');
        elmClear('message-box-btn-ok');
    }
    
    elmShow('message_bg');
};

PH.dismissMessage=function(){
    if(this.spinner)this.spinner.stop();
    elmClear('message_bg');
};
 
    
PH.onSettingsBtnNextClicked=function(){
    console.assert(typeof(this.settingShows)==='string' && this.settingShows.length===3);
    switch(this.settingShows){
    case 'lgn':this.validateLogin();break;
    case 'upl':this.validateUploads();break;
    case 'lng':this.validateLanguage();break;
    case 'reg':this.validateRegistration();break;
    case 'off':this.validateShutdown();break;
    case 'zip':this.validateDownloadZip();break;
    case 'lnk':elmClear('settings_bg');elmClear('settings_lnk');break;
    case 'abt':elmClear('settings_bg');elmClear('settings_abt');break;
    default:console.assert(0);
    }
};

PH.onSettingsBtnCancelClicked=function(){
    console.assert(typeof(this.settingShows)==='string' && this.settingShows.length===3);
    switch(this.settingShows){
        case 'upl':this.cancelUploads();break;
        default:
            elmClear('settings_bg');
            elmClear('settings_lng');
            elmClear('settings_reg');
            elmClear('settings_lnk');
            elmClear('settings_zip');
            elmClear('settings_off');
            elmClear('settings_abt');
            elmClear('settings_lgn');
    }
};

PH.validateUploads=function(){
    var continueCancel=true;
    var i,url,album='',subAlbum=elm('upl_subfolder').value.trim();
    console.log("subAlbum: <<"+subAlbum+">>");

    if(this.server.completedUploads===0){
        console.assert(subAlbum.length>0); //otherwise the Ok button should not be enabled
        continueCancel=confirm("Do you want to create \""+subAlbum+"\" as an empty subalbum? (You can add pictures or other albums to it later) Press Ok if yes.");
        if(!continueCancel)return;
    }

    //we need to create the upload url
    for(i=1;i<this.path.length;i++)
        album+='/'+this.path[i].a.id;
    
    if(album.length>0 || subAlbum.length>0){
        if(album.length>0){
            url='/u?a='+album;
            if(subAlbum.length>0)
                url+='&s='+encodeURIComponent(subAlbum);
        } else
            url='/u?s='+encodeURIComponent(subAlbum);
    } else
        url='/u';
    console.log("Upload URL: "+url);
    
    ajaxJson(url,function(obj){
        console.log("The answer from server:"+obj.a);
        console.assert(typeof(obj)==='object');
        console.assert(typeof(obj.a)!=='unknown');
        if(typeof(obj.a)==='string'){
            console.log("Upload failed: "+obj.a);
            PH.showMessage("Upload failed: "+obj.a,false);
            return;
        }
        //if we are here, the answer should be true or false
        console.assert(typeof(obj.a)==='boolean');
        if(obj.a){
            console.log("Upload succeeded!");
            //clear the subAlbum
            elm('upl_subfolder').value='';
        } else {
            console.log("Upload failed!");
            PH.showMessage("Upload failed! error: "+obj.err,false);
        }
    });
    this.server.completedUploads=0; //we reset this
    elm('settings_btn_next').disabled=true;
    
    elmClear('settings_bg');
    elmClear('settings_upl');
};

PH.cancelUploads=function(){
    var continueCancel=true;
    
    if(this.server.completedUploads>0)
        continueCancel=confirm("Do you really want cancel and delete from Photostovis all "+
            this.server.completedUploads+" uploaded files? Press Ok if yes.");
        
    if(!continueCancel)return;
    
    Dropzone.forElement("#ph_dropzone").removeAllFiles(true);
    console.log("Dropzone: removed all files");
    
    ajaxJson('/x',function(obj){
        console.log("The answer from server:"+obj.a);
        console.assert(typeof(obj)==='object');
        //if we are here, the answer should be true or false
        console.assert(typeof(obj.a)==='boolean');
        if(obj.a){
            console.log("Cancel upload succeeded!");
        } else {
            console.log("Cancel upload failed! err="+obj.err);
        }
    });
    this.server.completedUploads=0; //we reset this
    elm('upl_subfolder').value='';
    elm('settings_btn_next').disabled=true;
    
    elmClear('settings_bg');
    elmClear('settings_upl');
};

PH.validateLanguage=function(){
    var sel,i,lng=null;
    sel=document.getElementsByName('settings_lang');
    for(i=0;i<sel.length;i++)
        if(sel[i].checked){
            lng=sel[i].value;
            break;
        }
    elmClear('settings_bg');
    elmClear('settings_lng');

    if(lng!==this.user.language){
        this.user.language=lng;
        if(this.path.length===0){
            this.getServerMetadata();
            this.getAlbum(); //will retrieve the first album
        }
        else this.displayAlbum(); //we show again our album
    }
    console.assert(typeof(lng)==='string' && lng.length===2);
    this.savePreferences(true);
};

PH.validateRegistration=function(){
    var username=elm('settings_reg_un').value;
    var password=elm('settings_reg_pw').value;
    var password2=elm('settings_reg_pw2').value;
    var KMinPasswordLength=5;
    var KMinUsernameLength=5;
    var msg,pwHashed;
    
    //username should be at least 5 characters
    if(username.length<KMinUsernameLength){
        console.log("username is too short. Length: "+username.length);

        if(username.length===1)
            msg=this.l10n('txt_reg_un_too_short1').replace('%L',KMinUsernameLength);
        else
            msg=this.l10n('txt_reg_un_too_shortN').replace('%l',username.length).replace('%L',KMinUsernameLength);
        this.showMessage(msg,false);
        return;
    }
    
    //paswords should match and be at least 5 characters long
    if(password.length<KMinPasswordLength){
        console.log("password is too short. Length: "+password.length);

        if(password.length===1)
            msg=this.l10n('txt_reg_pw_too_short1').replace('%L',KMinPasswordLength);
        else
            msg=this.l10n('txt_reg_pw_too_shortN').replace('%l',password.length).replace('%L',KMinPasswordLength);
        this.showMessage(msg,false);
        return;
    }
    if(password!==password2){
        console.log("passwords do not match!");
        //TODO: display message
        return;
    }
            
    //register the username in photostovis.net
    pwHashed=CryptoJS.SHA256(password);
    ajaxJson('/r?un='+username+'&pw='+pwHashed,function(obj){
        console.log("The answer from server:"+obj.a);
        console.assert(typeof(obj)==='object');
        console.assert(typeof(obj.a)!=='unknown');
        if(typeof(obj.a)==='string'){
            console.log("Registration failed: "+obj.a);
            PH.showMessage("Registration failed: "+obj.a,false);
            return;
        }
        //if we are here, the answer should be true or false
        console.assert(typeof(obj.a)==='boolean');
        if(obj.a){
            console.log("Registration succeeded!");
            PH.showMessage("Registration succeeded!",false);
            //remove the attention sign
            elmHide('attention-btn');
            PH.getServerMetadata();
        } else {
            if(typeof(obj.msg)==='string'){
                console.log("Registration failed: "+obj.msg);
                PH.showMessage("Registration failed: "+obj.msg,false);
            } else {
                console.log("Registration failed!");
                PH.showMessage("Registration failed!",false);
            }
        }

    });
    
    //clear the registration dialog ...
    elmClear('settings_bg');
    elmClear('settings_reg');
    //...and display a waiting message
    this.showMessage("Registering with photostovis.net",true);
};

PH.validateDownloadZip=function(){
    //elm('settings_btn_next').disabled=true;
    
    //TODO
    /*
    var x=new XMLHttpRequest();
    x.onreadystatechange=function() {
        if(x.readyState===4){
            if(x.status===200){
                console.log(x.responseText);
                var obj=parseJSON(x.responseText);
                console.assert(typeof(obj)==='object');
                if(f)
                    f(obj);
            } else {
                console.warn("WARNING: XMLHttprequest failed: "+x.statusText);
                console.warn(x);
                if(f)
                    f();
            }
        }
    };
    x.open('GET',url,true);
    x.setRequestHeader("Content-Type", "application/json; charset=utf-8");
    x.timeout=20000; //20 seconds
    x.send(null);
    
    */
    
    
    
    elmClear('settings_bg');
    elmClear('settings_zip');
};
PH.validateShutdown=function(){
    ajaxJson('/z',PH.shutdownSent);
    elmClear('settings_bg');
    elmClear('settings_off');

    //...and display a waiting message
    PH.showMessage("Sending the shutdown message to your photostovis server.",true);
};
PH.validateLogin=function(){
    var pwHashed=CryptoJS.SHA256(elm('settings_lgn_pw').value);
    ajaxJson('/g?pw='+pwHashed,function(obj){
        console.log("The answer from server:"+obj.a);
        console.assert(typeof(obj)==='object');
        console.assert(typeof(obj.a)!=='unknown');
        if(typeof(obj.a)==='string'){
            console.log("Login failed: "+obj.a);
            PH.showMessage("Login failed: "+obj.a,false);
            return;
        }
        //if we are here, the answer should be true or false
        console.assert(typeof(obj.a)==='boolean');
        if(obj.a){
            console.log("Login succeeded!");
            //enable stuff
            PH.server.showSensitiveCommands=true;
            elm('menu_upload').className='menu-item';
            elm('menu_linkurl').className='menu-item';
            elm('menu_shutdown').className='menu-item';
            PH.sendMessageToFbFrame('photostovis_enable');
            elmHide('menu_login');
        } else {
            console.log("Login failed!");
            PH.showMessage("Login failed!",false);
        }
    });

    //clear the registration dialog ...
    elmClear('settings_bg');
    elmClear('settings_lgn');
}

PH.shutdownSent=function(obj){
    if(obj.a)
        PH.showMessage("Your Photostovis server is shutting down. Please wait untill all lights on the box are off.",false);
    else 
        PH.showMessage("You do not have permission to shut down this Photostovis server. You have to be connected locally.",false);
};


