"use strict";

Dropzone.options.phDropzone={
    parallelUploads:1,
    addRemoveLinks:false,
    maxFilesize:20480, //20GB
    init: function(){
        var that=this;
        this.on('success', function(file){
            PH.server.completedUploads++;
            PH.server.currentCompletedUploads++;
            var progress=PH.server.currentCompletedUploads*100/PH.server.queuedUploads;
            console.assert(progress<=100,"Completed uploads: "+PH.server.currentCompletedUploads+", Queued uploads: "+PH.server.queuedUploads);  
            elm('upl_progress_bar').style.width=progress+'%';
            //console.log("Progress: "+progress);
            
            setTimeout(function(){
                //console.log(file.previewElement);
                that.removeFile(file);
            },3000);
            setTimeout(function(){
                if(typeof(file.previewElement)==='object'){
                    file.previewElement.style.transition='opacity 1s linear';
                    file.previewElement.style.opacity='0.1';
                }
            },2000);
        });
        
        this.on('addedfile', function(file){
            PH.server.queuedUploads++;
            elm('settings_btn_next').disabled=true;
        });
        
        /*
        this.on('totaluploadprogress', function(totalUploadProgress, totalBytes, totalBytesSent){
            console.log("totalUploadProgress: "+totalUploadProgress+" "+totalBytesSent+"/"+totalBytes);
            elm('upl_progress_bar').style.width=totalUploadProgress+'%';
            if(totalUploadProgress!==100)
                elm('settings_btn_next').disabled=true;
            else 
                elm('settings_btn_next').disabled=false;
        });*/
        
        this.on('reset', function(){
            console.log("Dropzone queue reset!");
            elm('upl_progress_bar').style.width='0';
            PH.server.currentCompletedUploads=0;
            PH.server.queuedUploads=0;
        });
        this.on('queuecomplete', function(){
            elm('settings_btn_next').disabled=false;
            PH.server.currentCompletedUploads=0;
            PH.server.queuedUploads=0;
            setTimeout(function(){
                elm('upl_progress_bar').style.width='0';
            },3000);
        });
        
        
        /* This is how it should be done
        this.on('sending', function(file, xhr, formData) {
            formData.append("path", file.fullPath);
        });
        */

    }
};


PH.onDOMContentLoaded=function(){
    var imgdiv=elm('imgdiv'),infobox=elm('img-info');
    //vars used with the hash event
    var someElm,someTxt;
    var path2,hashValid,hashQuery,i;
    var preferencesObj;
    
    this.platform={
        name:'',
        version:0,
        pixelRatio:1,
        pixelRatioTxt:'',
        pixelRatioTxtThmbQm:'', //with question mark
        pixelRatioTxtThmbAm:'', //with &
        screenWidth:screen.width,
        screenHeight:screen.height,
        isTouch:false,
        pictureModeFullScreen:false, //this is set to true if we go fullscreen in the beginning. We need this var to prevent going fullscreen in picture mode
        smallDevice:false,
        transformPrefix:'',
        clickEvent:'',
        renderingTimePerMPixel:0,
        lastSentRenderingTimePerMPixel:0
    };
    this.user={ //should be valid values
        language:'en',
        skipImgHelp:false,
        showPicInfo:1,
        showFullscreenDlg:true,
        showcase:false
    };
    this.hash={
        hash:'',
        lastHash:'nothing',
        //lastAlbumHistoryPos:-1,
        //lastLoadedAlbumHash:'',
        //
        //hashGoBack:false,
        //reconstructHistoryStack:-1,
        targetPath:[],
        targetPathIsAlbum:true
    };
    this.server={
        metadata:null,
        websocket:null,
        websocketQueue:[],
        completedUploads:0,
        currentCompletedUploads:0,
        queuedUploads:0,
        showSensitiveCommands:true, //show Upload, Shutdown, Share
        key:null,
        phonetCfgStatus:{
            PhonetCfgCurlInitFailes:1,
            PhonetCfgErrCurlConnectionFailed:2,
            PhonetCfgErrAnswerParsingFailed:3,
            PhonetCfgErrAnswerOutsideRange:4,
            PhonetCfgNeverTriedToRegister:0xFF
        },
        albumFlags:{
            FlagIsAlbum:1,
            FlagIsVideo:2,
            FlagPhotoHasGPSInfo:4,
            FlagHasExifThumbnail:8,
            FlagRotatePlus90:16,
            FlagRotatePlus180:32,
            FlagFullFileMD5:64,
            FlagAlbumHasUndatedEntries:128,
            FlagSizeIsInKB:256,
            FlagHasDescription:512,
            FlagHasUserComment:1024,
            FlagHasDescriptionTxtEntry:2048,
            FlagHasNameOffset:4096,
            //runtime flags
            FlagHasScaledThumbnail:8192,
            FlagAlbumIsBeingScanned:16384,
            //extra defines
            FlagHasThumbnail:8200 //8+8192
        }
        /*statusFlagsPics:{
            StatusFlagPictureScanThreadActive:1,
            StatusFlagDoARescan:2, //after the current picture scan the system should do a rescan because there were modifications meanwhile
            StatusFlagFirstScanDone:4
        }*/
    };
    this.strip={
        bodyWidth:0,
        albmpictElmWidth:0,
        nrThumbnailsPerRow:0,
        maxNrThumbnailsPerRow:0,
        picThmbWidth:0,
        picThmbWidthInt:0,
        nrThumbnailsToLoad:10 //how many thumbnails to load at once. Should be bitrate dependent (min:1, max: 20. 1 for each Mbps)
    };

    /* Each path element has these properties:
     * .a (object): info about current album (including its id)
     * .e (array of objects): elements of the album. Each element has its own id
     * .index (number): the current index. This is -1 if the path element is top-most, and between 0 and e.length otherwise
     * .scrollTop (number): position in page
     */
    this.path=[];
    
    this.loadingAlbum='';
    this.inPictureMode=false;
    
    this.settingAllowDismiss=true;
    this.zipDownload=false;
    
    console.log("Document loaded");
    console.assert(this===PH);
    //document.body.addEventListener('touchmove',function(e){ e.preventDefault(); });
    //detect the platform
    if(typeof(navigator.userAgent)==='undefined'){
        console.warn("WARNING: navigator.userAgent not defined");
    } else if(navigator.userAgent.indexOf('iPhone')>0 || navigator.userAgent.indexOf('iPad')>0 || navigator.userAgent.indexOf('iPod')>0){
        this.platform.name='ios';
    } else if(navigator.userAgent.indexOf('Android')>=0){
        this.platform.name='android';
        if(navigator.userAgent.indexOf('Android 2')>=0){
            this.platform.version=2;
            //this.imgExt='.png';//Android 2 does not support svg
        }
    } else if(navigator.userAgent.indexOf('IEMobile/')>=0){
        this.platform.name='wp';
        if(navigator.userAgent.indexOf('IEMobile/9')>=0){
            this.platform.version=9;
        }
        else if(navigator.userAgent.indexOf('IEMobile/10')>=0)
            this.platform.version=10;
    } else if(navigator.userAgent.indexOf('Symbian')>=0)
        this.platform.name='symbian';
    if(typeof(window.devicePixelRatio)!=='undefined'){
        this.platform.pixelRatio=window.devicePixelRatio;
        this.platform.screenWidth=screen.width*window.devicePixelRatio;
        this.platform.screenHeight=screen.height*window.devicePixelRatio;
        console.assert(this.platform.pixelRatio===1 || this.platform.pixelRatio===2 || this.platform.pixelRatio===3);
        if(this.platform.pixelRatio>1)
            this.platform.pixelRatioTxt='?pr='+this.platform.pixelRatio;
    };
    this.platform.isTouch=!!('ontouchstart' in window) || !!('msmaxtouchpoints' in window.navigator);

    if(this.platform.pixelRatio===1){
        //disable the "retina" resolution "get image"
        elm('min-res-this-r').style.display='none';
        elm('min-res-all-r').parentNode.style.display='none';
    }

    //get our preferences (from local)
    if(typeof(localStorage)!=="undefined"){
        preferencesObj=localStorage.getItem('photostovisPreferences');
        if(preferencesObj)
            this.user=JSON.parse(preferencesObj);
        if(typeof(this.user.showPicInfo)==='boolean'){
            if(this.user.showPicInfo)this.user.showPicInfo=1;
            else this.user.showPicInfo=0;
        }

        if(parent!==self)
            this.savePreferences(false);
    } else {
        console.warn("No Storage object, there will be problems!");
    }
    //console.log("User preferences:");
    //console.log(this.user);

    if(this.platform.isTouch){
        //touch device
        this.platform.clickEvent='touchend';
        console.log("touch device detected");

        //make the top bar 4em instead of 7em
        elm('menu').style.height=elm('cntnt').style.top="4em";
        elm('album-title').style.margin="0";
        elm('album-picsnalbms').style.lineHeight="1em";
        elm('album-timebar').style.fontSize="0.7em"; //same as album-picsnalbms
        elm('album-timebar').style.lineHeight="1em";

        //toolbar elements:
        elmHide('fb_iframe');//hide the share button (for the moment)

        someElm=elm('menu-btn');
        someElm.style.height=someElm.style.width="4em";
        someElm.style.display='block';
        someElm.style.position='absolute';
        someElm.style.top=someElm.style.right='0';

        someElm=elm('attention-btn');
        someElm.style.height=someElm.style.width="1.2em";
        //someElm.style.display='block';
        someElm.style.position='absolute';
        someElm.style.top=someElm.style.right='1.4em';
        someElm.style.zIndex='10';

        //show full-screen dialog
        if(this.platform.name!=='ios' && this.user.showFullscreenDlg)
            this.showFullScreenDialog();
        //TODO: on ios show a "add to homescreen" dialog
    } else {
        //non-touch device
        this.platform.clickEvent='click';
        //add nontouch class to menu button
        elm('menu-btn').setAttribute('class','nontouch');
        elm('attention-btn').setAttribute('class','nontouch');
        //TODO: to other buttons as well
        console.log("non-touch device detected");
    }

    console.assert(this.platform.name===PH.platform.name,"Variable scope is screwed-up!");

    this.server.key=getURLParam(window.location,"key");
    console.log("Server key: "+this.server.key);
    
    this.computeThumbnailStrip(); //-> platform.smallDevice is set here
    console.assert(this.strip.nrThumbnailsPerRow>1,"nrThumbnailsPerRow="+this.strip.nrThumbnailsPerRow);

    //check for websocket support
    this.setupWebsocket();

    if(parent===self)//standalone
        this.getServerMetadata();
    
    //find the transform prefix
    if(typeof(imgdiv.style.webkitTransform)!=='undefined')this.platform.transformPrefix='-webkit-';
    if(typeof(imgdiv.style.msTransform)!=='undefined')this.platform.transformPrefix='-ms-';
    console.log("transformPrefix: "+this.platform.transformPrefix);
    
    setTimeout(function(){document.getElementById('menu').style.top="0";},0);
    
    //scrollfix
    someElm=elm('cntnt');
    someElm.scrollTop=1;
    someElm.addEventListener('scroll',function(){
        if(this.scrollTop<=0)
            this.scrollTop=1;
    },true);


    //console.log(location.host);
    
    //////////////////////////////////////////////////////////////////////////
    //bindings
    ////////////////////////////////////////////////////////////////////////////
    function showMenu(){
        //are we in full-screen mode?
        if(PH.platform.name==='ios'){
            //there is no full-screen in ios
            elmHide('menu_enter_fs');
            elmHide('menu_exit_fs');
        } else {
            if(PH.isFullScreen()){
                elmHide('menu_enter_fs');
                elmClear('menu_exit_fs');
            } else {
                elmClear('menu_enter_fs');
                elmHide('menu_exit_fs');
            }
        }
        elmShow('menu_bg');
    }
    
    addEventListener("message",function(e){
        console.log("!!!! Message received from iframe or parent:");
        console.log(e);
        if(e.origin!=='http://www.photostovis.net' && e.origin!=='http://photostovis.net'){
            console.warn("Ignoring message from unknown origin: "+e.origin);
            return;
        }
        if(typeof(e.data)==='string'){
            if(e.data==="sendme"){
                if(!PH.server.showSensitiveCommands)
                    PH.sendMessageToFbFrame('photostovis_disable');
                return;
            }
            if(e.data==="sharing_successfull"){
                //TODO:
                return;
            }
            if(e.data.slice(0,15)==="sharing_failed:"){
                //TODO: failed because of the Photostovis server
                console.warn("Sharing on FB failed: "+e.data.slice(15));
                return;
            }

            if(e.data==="get_fb_share_link"){
                //send the request to the server
                var url='/k',i;
                var fbIFrame=document.getElementById("fb_iframe");
                if(!fbIFrame || !fbIFrame.contentWindow || !PH.server.metadata || !PH.server.metadata.un){
                    console.warn("Cannot send link to FB frame: some data is missing.");
                    return;
                }
                console.log("Sending link to FB frame.");

                for(i=1;i<PH.path.length;i++)
                    url+='/'+PH.path[i].a.id;
                if(PH.server.key)
                    url+='?key='+PH.server.key;
                ajaxJson(url,function(obj){
                    var fbUrl;
                    if(typeof(obj)==='object'){
                        if(typeof(obj.link)==='string'){
                            fbUrl=obj.link.replace('/?key=','/a/?key=');
                            console.log("Sending link to FB frame: "+fbUrl);
                            fbIFrame.contentWindow.postMessage("photostovis_link="+fbUrl,"*");
                        } else if(typeof(obj.err)==='number')
                            console.warn("Cannot send link to FB frame: Server is not registered to phonet.");
                        else
                            console.warn("Cannot send link to FB frame: Unspecified error retrieving link from the server.");
                    } else
                        console.warn("Cannot send link to FB frame: Unspecified error retrieving link from the server (returned data not understood).");
                });
                return;
            }
        }
        
        if(typeof(e.data.photostovis_top_hash)==='string' && parent!==self){
            console.log("New hash received from parent: "+e.data.photostovis_top_hash);
            PH.hash.hash=e.data.photostovis_top_hash;
            //check if we have received user preferences
            if(typeof(e.data.localStorageTxt)==='string'){
                console.log("localStorageTxt: "+e.data.localStorageTxt);
                var preferencesObj=JSON.parse(e.data.localStorageTxt);
                preferencesObj.showFullscreenDlg=PH.user.showFullscreenDlg; //we do not overwrite this with the remote value

                if(typeof(preferencesObj.showPicInfo)==='boolean'){
                    if(preferencesObj.showPicInfo)preferencesObj.showPicInfo=1;
                    else preferencesObj.showPicInfo=0;
                }
                PH.user=preferencesObj;

                //save locally
                var jsonTxt=JSON.stringify(preferencesObj);
                localStorage.setItem('photostovisPreferences',jsonTxt);
            }
            //done checking for stored user preference
            //now check if we have server object
            if(typeof(e.data.server)==='object'){
                PH.server.ip=e.data.server.ip;
                PH.server.port=e.data.server.port;
                PH.server.ipNum=e.data.server.ipNum;
                //if the IP is not local (outside the 192.168.*.* range) we hide all the sensitive menus and show the Login menu
                console.log("ipNum: "+e.data.server.ipNum);
                if(e.data.server.ipNum<3232235520 || 3232301056<=e.data.server.ipNum){
                    PH.server.showSensitiveCommands=false;
                    elm('menu_upload').className='menu-item-disabled';
                    elm('menu_linkurl').className='menu-item-disabled';
                    elm('menu_shutdown').className='menu-item-disabled';
                    PH.sendMessageToFbFrame('photostovis_disable');
                    elmClear('menu_login');
                }
                elmHTML('about_server',PH.server.ip+':'+PH.server.port);
            }
            
            //do we have a language?
            //console.log("UserX language: "+PH.user.language+" of type: "+typeof(PH.user.language));
            if(typeof(PH.user.language)!=='string' || PH.user.language.length!==2){
                //PH.showLanguageSelector(true);
                PH.user.language='en';
            }
            console.assert(typeof(PH.user.language)==='string' && PH.user.language.length===2);
    
            PH.onHashChanged();
            return;
        }
        
        console.error("What exactly is going on here??");
    },false);
    
    //bind the hash stuff. We keep it here to have access to some vars from this (onDOMContentLoaded) function
    if(self===parent){
        addEventListener('hashchange',function(){
            PH.hash.hash=location.hash;
            PH.onHashChanged();
        },false);
        
        //check the initial hash
        this.path=[];
        if(location.hash===''){
            this.setHash('#a');
            this.getAlbum(); 
        } else {
            //we have a path, parse it
            hashValid=true;

            if(location.hash.length<=3 || location.hash[0]!=='#' || (location.hash[1]!=='a' && location.hash[1]!=='i') || location.hash[2]!=='/')
                hashValid=false;
            else {
                hashQuery=location.hash.split('?');
                if(typeof(hashQuery[1])!=='undefined')
                    console.log("Query: "+hashQuery[1]);
                console.log("Hash (without query): "+hashQuery[0]);

                if(typeof(hashQuery[1])!=='undefined'){
                    if(hashQuery[1]==='showcase'){
                        //we showcase this picture
                        this.user.showcase=true;
                    } else console.warn("Unknown hash query: "+hashQuery[1]);
                }

                path2=hashQuery[0].slice(3).split('/');
                console.assert(path2.length>0);
                
                for(i=0;i<path2.length;i++)
                    this.hash.targetPath.push(path2[i]);
                if(hashQuery[0][1]==='a')
                    this.hash.targetPathIsAlbum=true;
                else
                    this.hash.targetPathIsAlbum=false;
            }

            if(!hashValid){
                if(location.hash!=='#a')
                    console.warn("The hash ("+location.hash+") is not valid, loading the root album");
                this.getAlbum(); 
            } else {
                console.log("Hash contains an apparently valid path");

                PH.hash.lastHash=PH.hash.hash=hashQuery[0];
                this.getFullPath();
            }
        }
        
    } else {
        addEventListener('hashchange',function(){
            console.error("hashchange event detected in iframe");
        },false);
        
        //tell the parent to send us the initial hash
        parent.postMessage("sendme","*");
    }

    imgdiv.addEventListener(this.platform.clickEvent,function(ev){PH.handleClicks(ev,this)},false);
    if(this.platform.clickEvent!=='click')
        imgdiv.addEventListener('click',function(ev){PH.handleClicks(ev,this)},false); //we need real click for video

    elm('zoom').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        if(PH.albumCache.toggleZoom())
            ev.preventDefault(); //we toggled the zoom
        ev.stopPropagation();
    },false);
    elm('min-resolution').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        if(PH.albumCache.toggleResolutionMenu())
            ev.preventDefault(); //we opened the menu
        ev.stopPropagation();
    },false);
    elm('min-res-this-h').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.reloadThisPicture('h');
        ev.preventDefault();
        ev.stopPropagation();
    },false);
    elm('min-res-this-d').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.reloadThisPicture('d');
        ev.preventDefault();
        ev.stopPropagation();
    },false);
    elm('min-res-this-r').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.reloadThisPicture('r');
        ev.preventDefault();
        ev.stopPropagation();
    },false);
    elm('min-res-this-o').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.reloadThisPicture('o');
        ev.preventDefault();
        ev.stopPropagation();
    },false);
    elm('min-res-all-n').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.setMinimumResolution('n');
    },false);
    elm('min-res-all-h').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.setMinimumResolution('h');
    },false);
    elm('min-res-all-d').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.setMinimumResolution('d');
    },false);
    elm('min-res-all-r').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.setMinimumResolution('r');
    },false);
    elm('min-res-all-o').addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        PH.albumCache.setMinimumResolution('o');
    },false);

    infobox.addEventListener(this.platform.clickEvent,function(ev){
        if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
        if(PH.albumCache.toggleInfobox())
            ev.preventDefault(); //we toggled the infobox
        ev.stopPropagation();
    },false);
    infobox.children[3].addEventListener(this.platform.clickEvent,function(ev){ev.stopPropagation()},false);

    document.addEventListener('keydown',function(ev){
        if(!PH.albumCache)return;
        if(ev.keyCode===37)PH.albumCache.showPrev();
        if(ev.keyCode===39)PH.albumCache.showNext();
        if(ev.keyCode>=16 && ev.keyCode<=18)//shift, ctrl, alt
            PH.albumCache.toggleZoom();
    },false);
    
    window.addEventListener('resize',function(){
        console.log("In resize");
        if(PH.albumCache)
            PH.albumCache.resize();
        if(PH.path.length>0 && PH.path[PH.path.length-1].index===-1 && document.body.clientWidth!==PH.strip.bodyWidth){
            console.log("computing thumbnail strip");
            //TODO: these could be optimized (how?)
            PH.computeThumbnailStrip();
            PH.displayAlbum(true); //"true" preserves the position
        }
    },false);
    
    //menu related bindings
    //bind the menu button
    elm('menu-btn').addEventListener(this.platform.clickEvent,showMenu,false);
    elm('menu_bg').addEventListener(this.platform.clickEvent,function(){
        elmHide('menu_bg');
    },false);
    
    //bind the menu elements
    //"Login" menu item
    elm('menu_login').addEventListener(this.platform.clickEvent,function(){
        elmHide('menu_bg');
        PH.showLogin();
    },false);

    //"Enter fullscreen" menu item
    elm('menu_enter_fs').addEventListener(this.platform.clickEvent,function(){
        elmHide('menu_bg');
        //if we are here we are not in full-screen mode
        console.assert(!PH.isFullScreen());
        PH.platform.pictureModeFullScreen=false;
        if(!PH.user.showFullscreenDlg){
            PH.user.showFullscreenDlg=true;
            PH.savePreferences(true);
        }
        PH.enterFullScreen(true);
    },false);

    //"Exit fullscreen" menu item
    elm('menu_exit_fs').addEventListener(this.platform.clickEvent,function(){
        elmHide('menu_bg');
        //if we are here we ARE in full-screen mode
        console.assert(PH.isFullScreen());
        PH.platform.pictureModeFullScreen=true;
        PH.exitFullScreen(true);
    },false);
    //"Registration" menu item
    elm('menu_registration').addEventListener(this.platform.clickEvent,function(){
        PH.showRegistrationErr();
    },false);
    //"Upload" menu item
    elm('menu_upload').addEventListener(this.platform.clickEvent,function(){
        if(!PH.server.showSensitiveCommands){
            e.preventDefault();
            e.stopPropagation();
            return false;
        }
        PH.showUpload();
    },false);
    //"Share link" menu item
    elm('menu_linkurl').addEventListener(this.platform.clickEvent,function(){
        if(!PH.server.showSensitiveCommands){
            e.preventDefault();
            e.stopPropagation();
            return false;
        }
        PH.showLink();
    },false);
    //"Download as zip" menu link
    elm('menu_downloadzip').addEventListener(this.platform.clickEvent,function(){
        PH.showDownloadZip();
    },false);
    //"Language" menu item
    elm('menu_language').addEventListener(this.platform.clickEvent,function(){
        //elmHide('menu_bg');
        PH.showLanguageSelector();
    },false);
    //"Registration" menu item
    /*
    elm('menu_registration').addEventListener(this.platform.clickEvent,function(){
        PH.showRegistration();
    },false);*/
    //"Shutdown" menu item
    elm('menu_shutdown').addEventListener(this.platform.clickEvent,function(e){
        if(!PH.server.showSensitiveCommands){
            e.preventDefault();
            e.stopPropagation();
            return false;
        }
        PH.showShutdown();
    },false);
    //"Help" menu item
    elm('menu_help').addEventListener(this.platform.clickEvent,function(){
        window.open("http://photostovis.net/PhotostovisHelp.html","_blank");
    },false);
    //"About" menu item
    elm('menu_about').addEventListener(this.platform.clickEvent,function(){
        PH.showAbout();
    },false);
    
    //bind settings background and settings box
    elm('settings_bg').addEventListener(this.platform.clickEvent,function(){
        var e,i;
        //can we cancel the settings dialog?
        if(!PH.settingAllowDismiss)
            return; //dismissing the settings dialog is not allowed

        //clear settings_bg
        e=elm('settings_bg');
        e.style.display='';
        //we also clear all its children
        for(i=0;i<e.children.length;i++)
            e.children[i].style.display='';
    },false);
    
    elm('settings_box').addEventListener(this.platform.clickEvent,function(e){
        e.stopPropagation();
        //e.preventDefault();
    },false);
    
    //bind elements from the settings "dialog"
    elm('settings_lng').addEventListener('change',function(){
        elm('settings_btn_next').disabled=false;
    });


    
    //bind the attention button
    elm('attention-btn').addEventListener(this.platform.clickEvent,function(){
        if(PH.platform.isTouch)showMenu();//for touch platforms the attention-btn opens the menu
        else PH.showRegistrationErr();
    },false);




    someElm=elm('settings_reg_un');
    someElm.addEventListener('change',PH.onRegisterUsernameChanged,false);
    someElm.addEventListener('keypress',PH.onRegisterUsernameChanged,false);
    someElm.addEventListener('paste',PH.onRegisterUsernameChanged,false);
    someElm.addEventListener('input',PH.onRegisterUsernameChanged,false);

    someElm=elm('upl_subfolder');
    someElm.addEventListener('change',PH.onUploadSubfolderChanged,false);
    someElm.addEventListener('keypress',PH.onUploadSubfolderChanged,false);
    someElm.addEventListener('paste',PH.onUploadSubfolderChanged,false);
    someElm.addEventListener('input',PH.onUploadSubfolderChanged,false);

    
    elm('settings_btn_next').addEventListener(this.platform.clickEvent,function(ev){
        ev.stopPropagation();ev.preventDefault();
        PH.onSettingsBtnNextClicked();
    },false);
    elm('settings_btn_cancel').addEventListener(this.platform.clickEvent,function(ev){
        ev.stopPropagation();ev.preventDefault();
        PH.onSettingsBtnCancelClicked();
    },false);

    //bind the buttons from the "enter full screen" dialog
    if(this.platform.isTouch && this.platform.name!=='ios'){
        console.log("binding buttons");
        elm('settings_efs_yes').addEventListener(this.platform.clickEvent,function(ev){
            ev.stopPropagation();ev.preventDefault();
            elmClear('settings_bg');
            elmClear('settings_lng');
            PH.enterFullScreen(true);
        },false);
        elm('settings_efs_no1').addEventListener(this.platform.clickEvent,function(ev){
            ev.stopPropagation();ev.preventDefault();
            elmClear('settings_bg');
            elmClear('settings_lng');
        },false);
        elm('settings_efs_no2').addEventListener(this.platform.clickEvent,function(ev){
            ev.stopPropagation();ev.preventDefault();
            elmClear('settings_bg');
            elmClear('settings_lng');
            //save "do not show this"
            PH.user.showFullscreenDlg=false;
            PH.savePreferences(true);
        },false);
    }
};

PH.computeThumbnailStrip=function(){
    var albmpictElmHeight,idealWidth;
    //is this a small device (e.g. mobile phone?)
    if(document.body.clientWidth<=736 && document.body.clientHeight<=736){
        this.platform.smallDevice=true;
        idealWidth=70;
    } else {
        this.platform.smallDevice=false;
        idealWidth=142;
    }
    if(this.platform.smallDevice && this.platform.pixelRatio>1){
        this.platform.pixelRatioTxtThmbQm='';
        this.platform.pixelRatioTxtThmbAm='';
    } else {
        this.platform.pixelRatioTxtThmbQm=this.platform.pixelRatioTxt;
        this.platform.pixelRatioTxtThmbAm='&'+this.platform.pixelRatioTxt.slice(1);
    }
    if(this.platform.smallDevice)
        console.log("This is a small device with thumbnail pixel ratio: "+this.platform.pixelRatioTxtThmbQm);
    else
        console.log("This is NOT a small device. Width: "+document.body.clientWidth);

    this.strip.bodyWidth=document.body.clientWidth;
    this.strip.albmpictElmWidth=Math.floor(document.body.clientWidth*0.98);
    this.strip.nrThumbnailsPerRow=Math.floor((this.strip.albmpictElmWidth-1)/idealWidth);
    this.strip.picThmbWidth=(this.strip.albmpictElmWidth-1)/this.strip.nrThumbnailsPerRow-1;
    this.strip.picThmbWidthInt=Math.floor(this.strip.picThmbWidth);
    if(document.body.clientWidth<document.body.clientHeight){
        albmpictElmHeight=Math.floor(document.body.clientHeight*0.98);
        this.strip.maxNrThumbnailsPerRow=Math.floor((albmpictElmHeight-1)/idealWidth);
        console.assert(this.strip.maxNrThumbnailsPerRow>=this.strip.nrThumbnailsPerRow);
    } else this.strip.maxNrThumbnailsPerRow=this.strip.nrThumbnailsPerRow;
    console.log("computeThumbnailStrip: maxThumbnails: "+this.strip.maxNrThumbnailsPerRow+", per row: "+this.strip.nrThumbnailsPerRow);
};

PH.handleClicks=function(ev,div){
    //returns true if we are to stopPropagation, false otherwise
    var clientX,currentZoom,isVideo;
    if(!this.albumCache)return false;
    if(typeof(ev.button)==='number' && ev.button!==0)return; //mouse click, other than left button
    if(typeof(ev.changedTouches)!=='undefined')clientX=ev.changedTouches[0].pageX;
    else clientX=ev.clientX;
    console.assert(typeof(clientX)==='number');

    currentZoom=this.albumCache.currentElmZoom();
    isVideo=this.albumCache.currentIsVideo();
    if((currentZoom!==0 || isVideo) && ev.type!=='click'){
        console.log("Non-click event on zoomed element or video element, ignoring.");
        return;
    }


    if(currentZoom===0 && ev.type==='click' && 'click'!==this.platform.clickEvent && !isVideo){
        console.log("Click event on non-zoomed, non-video element, ignoring.");
        return;
    }

    console.log("In handleClicks, handling the event. Type: "+ev.type);

    //if here we are handling the event
    ev.preventDefault();
    ev.stopPropagation();


    if(elm('min-res-container').style.display==='block'){
        this.albumCache.toggleResolutionMenu();
        return;
    }

    if(clientX<div.clientWidth/3 ){
        //go to previous image
        this.albumCache.showPrev();
        return;
    }
    if(clientX>div.clientWidth*2/3){
        //go to next image
        this.albumCache.showNext();
        return;
    }
    //if here, we need to return to our album
    this.path[this.path.length-1].index=-1;
    this.setHash();
};

PH.goOneLevelUp=function(){
    console.log("Going one level up");
    PH.path.pop();
    PH.albumCache.clear(true);//true -> total
    PH.setHash();
};

PH.sendMessageToFbFrame=function(msg){
    console.log("sendMessageToFbFrame: "+msg);
    //send our path to the fb_iframe
    var fbIFrame=document.getElementById("fb_iframe");
    if(fbIFrame && fbIFrame.contentWindow){
        console.log("Posting message. Type: "+typeof(msg));
        fbIFrame.contentWindow.postMessage(msg,"*");
    }
};

PH.setHash=function(hash){
    if(typeof(hash)==='undefined'){
        console.log("setHash: getting hash from path");
        hash=this.getHashFromPath();
    }
    console.log("setHash: "+hash);
    if(parent!==self){
        console.log("Sending hash to parent: "+hash);
        parent.postMessage({photostovis_hash:hash},"*");
    } else
        location.hash=hash;
};

PH.onHashChanged=function(){
    var i,v,index;
    var path2,hashQuery,p;
    var albumElements,id2find;
    var recreatePath=false;
    console.assert(this===PH);
    console.log("onHashChanged++: "+this.hash.hash+" (lastHash: "+this.hash.lastHash+") path length="+this.path.length);
    if(this.hash.hash===this.hash.lastHash){
        console.log("lastHash is the same, ignoring");
        return;
    }
    if(this.hash.hash==='#a' && this.hash.lastHash===''){
        console.log("Initial hash change, ignoring.");
        return;
    }
    if(this.hash.hash===''){
        this.setHash('#a');
        return;
    }
    
    //verify the path object
    for(i=0;i<this.path.length;i++){
        console.assert(typeof(this.path[i])==='object','Path element '+i+' is not an object.');
        v=this.path[i];
        console.assert(typeof(v.a)==='object','path['+i+'].a is not an object');
        console.assert(typeof(v.e)==='object','path['+i+'].e is not an object/array');
        console.assert(typeof(v.scrollTop)==='number','path['+i+'].scrollTop is not a number');
        console.assert(typeof(v.index)==='number','path['+i+'].index is not a number');
        console.assert(v.index===-1 || (v.index>=0 && v.index<v.e.length),'path['+i+'].index ('+v.index+') has improper value');
        console.assert(typeof(v.id)==='undefined','path['+i+'].id exists but it should not');
        console.assert(typeof(v.nr)==='undefined','path['+i+'].nr exists but it should not');
    }

    //LETS NOT FORGET: hash (path2) IS THE MASTER. this.path obeys and it is modeled by path2
    
    hashQuery=this.hash.hash.split('?');
    if(typeof(hashQuery[1])!=='undefined')
        console.log("Query: "+hashQuery[1]);
    console.log("Hash (without query): "+hashQuery[0]);
    //update the path array from the this.hash.hash  (hashQuery[0)
    if(hashQuery[0].length>3){
        path2=hashQuery[0].slice(3).split('/');
    } else path2=[];
    console.log("path.length="+this.path.length+" path2.length="+path2.length+". path2:");
    console.log(path2);
    
    if(typeof(hashQuery[1])!=='undefined'){
        if(hashQuery[1]==='showcase'){
            //we showcase this picture
            this.user.showcase=true;
        } else console.warn("Unknown hash query: "+hashQuery[1]);
    }
    /*if(typeof(hashQuery[1])!=='undefined'){
        var keyPos=hashQuery[1].search('key=');
        if(keyPos>=0){
            this.hash.key=hashQuery[1].slice(keyPos+4);
            console.log("key: "+this.hash.key);
        }
    }*/
    
    //this.path should be consistent with path2, otherwise we should recreate everything
    //we throw away from path all extra elements
    while(path2.length+1<this.path.length){
        console.log("Popping last element ("+(this.path.length-1)+") from path.");
        this.path.pop();
    }
    if(path2.length>this.path.length)
        recreatePath=true;
    else {
        console.assert((path2.length===this.path.length || path2.length+1===this.path.length));
        if(hashQuery[0][1]==='a'){
            //this is an album URL
            console.log("THIS IS an album URL");
            //Check first if the paths match
            for(i=0;i<path2.length;i++){
                index=this.path[i].index;
                console.log("index for i="+i+": "+index);
                if(index===-1 || path2[i]!==this.path[i].e[index].id){
                    recreatePath=true;
                    console.log("Recreating the path");
                }
            }
            if(!recreatePath){
                if(path2.length===this.path.length)
                    this.getAlbum();//we need to load the album. 
                else {
                    //reset the index of the last path element
                    this.path[this.path.length-1].index=-1;
                    //show the last album
                    if(this.inPictureMode){
                        //if we were in picture mode we do not need to load anything!
                        //this.inPictureMode=false; -> changed inside getOut()
                        this.albumCache.getOut();
                    } else {
                        if(this.server.metadata){
                            //do we have the data??
                            if(typeof(this.path[0].invalid)==='undefined' || !this.path[0].invalid){
                                this.displayAlbum();
                                //send to the server the album being displayed
                                if(this.server.websocket){
                                    p='/e';
                                    for(i=0;i<this.path.length-1;i++)
                                        p+='/'+this.path[i].e[this.path[i].index].id;
                                    ajaxJson(p,null);
                                }
                            } else {
                                //build target path first
                                this.hash.targetPath=[];
                                this.hash.targetPathIsAlbum=true;
                                for(i=0;i<this.path.length-1;i++)
                                    this.hash.targetPath.push(this.path[i].e[this.path[i].index].id);
                                this.path=[];
                                this.getFullPath();
                            }//we need to load the entire thing. 
                        }
                        //else we display it when we get the metadata
                    }
                }
            }
        } else {
            //this is an image, video or thumbnail URL
            //if the path lengths are different, pop the last album
            if(path2.length!==this.path.length)this.path.pop();
            
            //Check first if the paths match
            for(i=0;i<path2.length-1;i++){
                index=this.path[i].index;
                if(index===-1 || path2[i]!==this.path[i].e[index].id)
                    recreatePath=true;
            }
            if(!recreatePath){
                //show pictures
                index=this.path[this.path.length-1].index;
                if(index===-1){
                    //we need to find the index
                    id2find=path2[path2.length-1];
                    albumElements=this.path[this.path.length-1].e;
                    for(i=0;i<albumElements.length;i++)
                        if(albumElements[i].id===id2find){
                            index=i;
                            break;
                        }
                    //we also need to go fullscreen
                    elmShow('fullscreendiv');
                    this.enterFullScreen();
                    elmShow('imgdiv');
                    if(!this.user.skipImgHelp && !this.user.showcase)
                        this.showImgHelp();
                }
                console.assert(index>=0,"index="+index);

                //this.inPictureMode=true; -> changed inside displayMedia
                this.albumCache.displayMedia(index);
            }
        }
    }
    
    
    if(this.hash.lastHash==='nothing')
        this.getServerMetadata();
        
    if(!recreatePath){
        this.hash.lastHash=hashQuery[0];
        return;
    } //we are done
    
    console.log("onHashChanged: Recreating the path: "+this.hash.hash);
    console.assert(path2.length+1>=this.path.length,"Lenths mismatch: "+path2.length+"+1>="+this.path.length);
    
    for(i=0;i<this.path.length;i++){
        index=this.path[i].index;
        if(index===-1 || this.path[i].e[index].id!==path2[i])
            break;
    }
    while(this.path.length>i)
        this.path.pop();
    this.hash.targetPath=path2;
    if(hashQuery[0][1]==='a')
        this.hash.targetPathIsAlbum=true;
    else
        this.hash.targetPathIsAlbum=false;
    console.log("Recreating the path from truncated path:");
    console.log(this.path);
    this.getFullPath();
};//onHashChange

PH.setupWebsocket=function(){
    if(typeof(window.WebSocket)==='undefined'){
        console.log("This platform does NOT have WebSockets");
        return;
    }

    this.server.websocket=new WebSocket('ws://'+location.host, "status.photostovis.net");
    this.server.websocket.onerror=function(e){
        console.warn("Websocket error:");
        console.log(e);
    }
    this.server.websocket.onclose=function(e){
        console.warn("Websocket closing:");
        console.log(e);
    }
    this.server.websocket.onopen=function(e){
        var x;
        console.log("Websocket opened successfully.");
        //console.log(e);
        //sending all the messages from the queue
        if(PH.server.websocketQueue.length){
            console.log("websocket queue containing "+PH.server.websocketQueue.length+" elements. Sending them:");
            while(PH.server.websocketQueue.length){
                x=PH.server.websocketQueue.shift();
                console.log("Sending over websocket: "+x);
                PH.server.websocket.send(x);
            }
        }
    }

    this.server.websocket.onmessage=function(e){
        console.log("New WEBSOCKET data received."+e.data);
        var obj=JSON.parse(e.data);
        var p,i,txt;
        console.assert(typeof(obj)==='object');
        //console.log(obj);
        if(typeof(obj.type)!=='string'){
            console.error("Unhandled websocket message (does not have a type)");
            return;
        }
        
        switch(obj.type){
        case 'br':
            console.log("Bitrate: "+obj.b);
            PH.showBitrate(obj.b);
            //recompute the number of nrThumbnailsToLoad
            p=obj.b>>=10;
            if(p<1)p=1;
            if(p>20)p=20;
            if(p!==PH.strip.nrThumbnailsToLoad){
                console.log("Updating nrThumbnailsToLoad from "+PH.strip.nrThumbnailsToLoad+" to "+p);
                PH.strip.nrThumbnailsToLoad=p;
            }
            break;

        case 'md':
            PH.applyServerMetadata(obj);
            break;

        case 'album':
            console.log("WE HAVE RECEIVED AN ALBUM UPDATE!");
            if(PH.path.length){
                //mark the path as invalid
                PH.path[0].invalid=true;
                if(PH.server.metadata){
                    //is this the album that we have requested?
                    if(PH.path[PH.path.length-1].a.id!==obj.a.id){
                        console.log("Received a different album than what we are currently displaying. Ignoring");
                        //send the server our current album
                        p='/e';
                        for(i=0;i<this.path.length-1;i++)
                            p+='/'+this.path[i].e[this.path[i].index].id;
                        ajaxJson(p,null);
                        return;
                    }
                    //do we display or redisplay album?
                    var oldElm=PH.path[PH.path.length-1].e;
                    var newElm=obj.e;
                    i=-1;
                    if(oldElm.length===newElm.length){
                        for(i=0;i<newElm.length;i++){
                            //was the album re-sorted?
                            if(oldElm[i].id!==newElm[i].id){
                                console.log("Will display the received album (IDs do not match for i="+i+"), probably re-sorted");
                                break;
                            }
                            //will a new element be displayed (because pictures+videos !== zero anymore)?
                            if((newElm[i].p+newElm[i].v===0 && oldElm[i].p+oldElm[i].v!==0) ||
                                    (newElm[i].p+newElm[i].v!==0 && oldElm[i].p+oldElm[i].v===0)){
                                console.log("Will display the received album (new elements will be displayed this time)");
                                break;
                            }
                        }//for(...
                    } else console.log("Will display the received album (has different length than existing data)");

                    if(PH.path[PH.path.length-1].index===-1){
                        //we are NOT in picture showing mode
                        if(i===newElm.length)
                            PH.reDisplayAlbum(obj);
                        else {
                            PH.path[PH.path.length-1].a=obj.a;
                            PH.path[PH.path.length-1].e=obj.e;
                            PH.displayAlbum(true); //"true" preserves the position
                        }
                    } else {
                        console.log("Showing a picture. Will display the album on exit from picture mode.");
                        PH.path[PH.path.length-1].a=obj.a;
                        PH.path[PH.path.length-1].e=obj.e;
                    }

                }
            } else {
                console.log("There are no elements in the path. Will display this, although might be better to ignore it?");
                obj.scrollTop=0;
                obj.index=-1;
                PH.path.push(obj);
                if(PH.server.metadata)
                    PH.displayAlbum();
            }
            break;

        case 'zipdld':
            console.log("Received a zip download message:");
            console.log(obj);
            if(typeof(PH.zipDownload)==='boolean' && PH.zipDownload===false)
                return; //we ignore the message, we do not need it (download either ongoing or cancelled)

            if(typeof(obj.prg)==='number'){
                elm('zip_progress_bar').style.width=obj.prg+'%';
            } else if(typeof(obj.link)==='string'){
                elm('zip_progress_bar').style.width='100%';
                //start the download
                console.log("Download link: "+obj.link);
                window.location=obj.link;
                //dismiss the settings window
                elmClear('settings_bg');
                elmClear('settings_zip');
                //clear the zip object
                PH.zipDownload=false;
            } else console.error("Unrecognized zipdownload message");
            break;

        default:
            console.error("Unhandled message, type: "+obj.type);
        }//switch
    };//websocket.onmessage
};

PH.sendWebsocketMessage=function(msg){
    setTimeout(function(){
        var err;
        if(typeof(window.WebSocket)==='undefined'){
            console.warn("This platform does not implement WebSockets, and no alternative method is implemented!");
            //TODO: send the message as e.g. PUT
            return;
        }

        console.log("sendWebsocketMessage. State="+PH.server.websocket.readyState);
        if(PH.server.websocket.readyState!==WebSocket.OPEN){
            PH.server.websocketQueue.push(msg);
            PH.setupWebsocket();
            return;
        }

        try{
            PH.server.websocket.send(msg);
        } catch(err){
            console.warn("Sending websocket message failed with error: "+err.message+". Will try re-opening the socket");
            PH.server.websocketQueue.push(msg);
            PH.setupWebsocket();
        }
    },0);
};

//start
document.addEventListener('DOMContentLoaded',function(){
    PH.onDOMContentLoaded();
},false);

